/*------------------------------------------------*/
/* 44http/client-work-http.c                      */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "connection.h"
#include "../definice.h"

char * clientWork(descriptors * fd)
{
    FILE *fr, *fw;
    char s[256];
    int hdr, i;
    char *headers[] = {
        "GET " HTTP_VER_URL NAZEV1 "?ver=" VER "&appid=" UNIQUEID "&user=",
	" HTTP/1.0\r\n",
        "Host: " HTTP_HOST "\r\n",
        "User-Agent: Links (2.7; Linux 3.11.10-21-desktop x86_64; GNU C 4.8.1; text)\r\n",
        NULL
    };
    char * mem = NULL;
    char * user = NULL;
    size_t memsize = sizeof(s);

    fr = fdopen(fd->r, "r");
    fw = fdopen(fd->w, "w");

    /* poslani hlavicek */
    i = 0;
    while (headers[i]) {
        fputs(headers[i], fw);
	if(i == 0) {
	    user = getenv("USER");
	    //TODO:sanitize username
	    if(user)
		fputs(user,fw);
	}
        i++;
    }
    fputs("\r\n", fw);
    fflush(fw);

    /* nacteni odpovedi */
    hdr = 1;
    while (fgets(s, sizeof(s), fr)) {
        if (!strcmp(s, "\r\n")) {
            hdr = 0;
            continue;
        }
        if (hdr) {
	 continue;
	}
	i = mem  ? 1 : 0;
	//TODO: optimalizovat, takhle se alokuje mnohem vic, nez je potreba (protoze strlen(s) << sizeof(s))
	mem = realloc(mem, memsize);
        if(!mem) return NULL;
	if(i)
	    strncat(mem, s, sizeof(s));
	else
	    strncpy(mem, s, sizeof(s));
	memsize += sizeof(s);
    }
    return mem;
}

/*------------------------------------------------*/
